package Drag_n_Drop;
import java.awt.Container;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
/**
 * Main class: Get local host information; 
 *             Create instance of FStree; 
 *             Start GUI.  
 */
public class FileXchange {
        //Main frame window
        public static JFrame f;
        static public FSTree bt;
        static public boolean send_lock=false;
        static public String local_host;//IPAddress+(port)
        static public int service_port;
        /**
         * Constructor of Main class, find a free port as service port, register the
         * service
         * @throws java.lang.Exception
         */
        public FileXchange() throws Exception {
              try{
                    //get a free ephemeral port as service port
                    ServerSocket server = new ServerSocket(0);
                    this.service_port=server.getLocalPort();
                    server.close();
                    local_host=InetAddress.getLocalHost().getHostName()+"("+server.getLocalPort()+")";
                    f.setTitle("Drag-N-Drop File Exchange : "+local_host);
                    try{
                    FileReader fr=new FileReader("config.ini");
                    BufferedReader br=new BufferedReader(fr);
                    Receive.saveDirectory=br.readLine().split("=")[1];
                    br.close();
                    fr.close();
                    }
                    catch(Exception e){
                         File newf = new File("config.ini"); 
                         newf.createNewFile();   
                    }
                   
                }
                catch(Exception e){
                }
           
        }
        /**
         * Main method: start GUI
         * 
         */
        public static void main(String[] args) {
                
	        f = new JFrame("FileXChange");
                try {
                    new FileXchange(); 
                }
		catch (Exception e) { 
                    e.printStackTrace(); 
                }
		
		//Start GUI 
		startGUI();
	}
	/**
         * This method is used to create GUI
         * @see  FSTree
         */
	private static void startGUI() {
            
            // add components to the frame
	    Container content = f.getContentPane();
            content.setLayout(new BoxLayout(content, BoxLayout.PAGE_AXIS));
	    bt = new FSTree("Peer Nodes                 ");
            JScrollPane listPane2 = new JScrollPane(bt);
            listPane2.setBorder(new EmptyBorder(9, 9, 9, 9));
            JPanel pane0 = new JPanel();
            bt.setBorder( new EmptyBorder( 10, 5, 13, 40) );
            pane0.add(listPane2);
	    content.add(pane0);
	    JPanel pane = new JPanel();
            JButton button=new JButton("About");
            //Show information about the application
            button.addActionListener(new ActionListener(){
                    public void actionPerformed(ActionEvent e){
                        JOptionPane.showMessageDialog(null,"                              Drag and Drop File Sharing Application\r\n"
                                                      +"                                                Version 1.0\r\n"
                                                      +"Author: Ming Ge, Columbia University.\r\n"
                                                      +"--Based on Suman Suman R. Srinivasan's BonAHA library and Apple's Bonjour technology."+"\r\n"
                                                      +"--Partial codes are from Suman R. Srinivasan's 'Drag-n-Drop File Exchange' application.\r\n");
                    }                                  
                }
            
            );
            pane.add(button);
	    content.add(pane);
	    f.pack();
	    f.setVisible(true);
	    f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        }
}






