/*
 * Send.java
 *
 * Created on October 21, 2008, 11:55 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Drag_n_Drop;
import java.net.*;
import java.io.*;
import javax.swing.*;
/**
 * Run as a thread to send file and handle exceptions during transfer.
 * Create instance of SendBar to show sending progress.
 * @see  SendBar
 */
class Send extends Thread{
     // socket to send file
     public Socket socket;
     // recipient's IP address and port number
     public String remote_host;
     //recipient's host name and port number
     public static String remote_host_display;
     //name of the file to send including abosulte path
     public String filename;
     //name of the file to send
     public static String displayFileName="";
     //length of the file to send
     public static int length_sent=0;
     //length of file that has been sent
     public static int length_file=0;
     //indicate if the sender cancel
     public static boolean send_stop=false;
     // indicate the sending finishes(not mean successful)
     public static boolean sent_finish=false;
     public String node_sending;
     /**
      * Constructor of Send class
      * @param host_temp: destination IP address and 
      * @param filename_temp: file name(include absolute path)to send
      * @param local_host_temp: local host name and service port
      */
     Send(String host_temp,String remote_name,String filename_temp){
         remote_host=host_temp;
         node_sending=remote_name;
         filename=filename_temp;
         displayFileName=new String(filename);
         if(filename.contains("\\")){
              displayFileName=new String(filename.split("\\\\")[filename.split("\\\\").length-1]);
         }
     }
     /**
      * Send file to the target and handle the exceptions.
      * Create SendBar to show progressbar.
      * @see SendBar.
      */
    public void run (){	
        try{       
                int BUFFER_SIZE=320;
                while(FileXchange.send_lock){}
                FileXchange.send_lock=true;//can only run one send thread at one time
                //Initiate parameters.
                length_sent=0;
                sent_finish=false;
                send_stop=false;
                FileInputStream fis=new FileInputStream(filename);
                int tmp=remote_host.split("/").length;
                String IP=remote_host.split("/")[tmp-2];
                String remote_port=remote_host.split("/")[tmp-1];
                remote_host_display=IP+"("+remote_port+")";
		socket = new Socket(IP,Integer.valueOf(remote_port));
                //stream for reading reply from recipient
                InputStream in_from_receiver= socket.getInputStream();
		//stream for sending file data
                OutputStream out =new BufferedOutputStream(socket.getOutputStream());
                this.length_file=fis.available();
                //stream for control data
                DataOutputStream out_to_receiver=new DataOutputStream(socket.getOutputStream());
                //Byte[]tmp=("displayFileName+"\n");
                //send file name
                out_to_receiver.writeUTF(displayFileName);
                byte[]buffer = new byte[BUFFER_SIZE];
                //send local host name and port number
                out_to_receiver.writeUTF(FileXchange.local_host);
                //send file length
                out_to_receiver.writeUTF(""+this.length_file);
                //wait for recipient to respond
                socket.setSoTimeout(60000);// the time for receiver to accept or decline
                int i=in_from_receiver.read();
                //i==2 decline, i==1 accept
                if(i==2){
                    JOptionPane.showMessageDialog(FileXchange.f,"Recipient "+node_sending+" declined the file '"+displayFileName+"'");
                    this.sent_finish=true;
                    FileXchange.send_lock=false;
                    return;
                }
                socket.setSoTimeout(0);// no response need during data packets transfer
                SendBar sendBar=new SendBar();//start the progress bar for sending
                sendBar.start();
		while (!send_stop) {
			int nBytes = fis.read(buffer, 0, BUFFER_SIZE);
			if (nBytes < 0)// the end of the stream
				break;
			out.write(buffer, 0, nBytes);
                        this.length_sent+=nBytes;
                        if(this.length_sent==length_file)//complete sending
                            break;
		}
                this.sent_finish=true;
		/* Close streams */
		out.flush();
		out.close();
		//in.close();
                fis.close();
                if(this.length_sent<length_file&&send_stop==true)
                    JOptionPane.showMessageDialog(FileXchange.f,"You canceled sending '"+displayFileName+"' to "+this.remote_host_display+"!");
                FileXchange.send_lock=false;
     }
     catch(Exception e){
        //System.out.println(e);
        if(!this.send_stop)
            JOptionPane.showMessageDialog(FileXchange.f,"Transfer of file '"+displayFileName+"' failed. \r\nThere was no response from the receiver - it might have left the network, or canceled transfer.");
        this.sent_finish=true;
        FileXchange.send_lock=false;
               
     }
   }
}
/**
 * Create instance of ProgressBar to show progress during sending.
 * @see ProgressBar
 */
class SendBar extends Thread{//start sending progress bar
    public ProgressBar pbd;
    /**
     * Run method to create send bar.
     */
    public void run(){
        pbd=new ProgressBar("send");
        pbd.setSize(300,150);
        pbd.setLocation(FileXchange.f.getLocation());
        pbd.setVisible(true);
        pbd.setTitle("Sending "+Send.displayFileName+" to "+Send.remote_host_display);
        pbd.run();
    }

}